// parameter definitions for 11-isogeny map
//
// (C) 2019 anonymous authors. All rights reserved.
// clang-format off

#include "iso.h"

const uint64_t ELLP_a[6] = { 0x5cf428082d584c1dLL, 0x98936f8da0e0f97fLL, 0xd8e8981aefd881acLL, 0xb0ea985383ee66a8LL, 0x3d693a02c96d4982LL, 0x144698a3b8e943LL, };

const uint64_t ELLP_b[6] = { 0xd1cc48e98e172be0LL, 0x5a23215a316ceaa5LL, 0xa0b9c14fcef35ef5LL, 0x2016c1f0f24f4070LL, 0x18b12e8753eee3bLL, 0x12e2908d11688030LL, };

const bint_ty iso_xnum[ELLP_XMAP_NUM_LEN] = {
    {  0x0ff3af0030c68dLL,  0x980858ae8c656fLL,  0x50bb941b8b5055LL,  0x566f7fb4488cb7LL,  0xb13d41ef70f3baLL,  0xc92d3ebb84a25aLL,  0x00095ee59c2347LL,  },
    {  0xca385cdbd48ae9LL,  0x3d220dc2aa9c67LL,  0x924f70e2803588LL,  0xc3459f7ec7b8ceLL,  0x1ce57823c7c377LL,  0x857b73b9bab1eaLL,  0x000731f178080bLL,  },
    {  0xa13a480b7ea03dLL,  0xc0865474c6b938LL,  0x68803f76afb25dLL,  0x91fe8ec7360321LL,  0x6c2fefae8d3767LL,  0x62e003b69d83f9LL,  0x0019c7030cfadcLL,  },
    {  0xb02870f756eb7bLL,  0x30789644217068LL,  0xab1672bf7e79d1LL,  0xe867e73c5111d1LL,  0x0cfcb37f5bb8e6LL,  0x1b35e66ac958b9LL,  0x000d3b3013e2a9LL,  },
    {  0xd84bd6a76d9a35LL,  0x8ac08edd85ab74LL,  0xb5ace720cb3af0LL,  0x9f144189010984LL,  0xce11733af083bbLL,  0x95a01bbf470a6aLL,  0x0017a6e3ce89b5LL,  },
    {  0x88e2f436786159LL,  0x9be21773bdb0dcLL,  0x0c6c992d13ed90LL,  0x7065e9e6708bcfLL,  0xdc350ae46986baLL,  0x780646b5c69feeLL,  0x0011b9a68b2f21LL,  },
    {  0xa5c953406a5219LL,  0x6a456debe95544LL,  0x5f3ac15bf09463LL,  0xccc0cdd8438851LL,  0x316386d70433e1LL,  0xf3e8be0ad5c7deLL,  0x00153e1c947e7aLL,  },
    {  0x45490f06c4fb39LL,  0xa8ef5019819133LL,  0x3fa2a25687c978LL,  0xacde2b8596fa65LL,  0xe08e5e49e351e0LL,  0x9780b04642dc8bLL,  0x00150787310a58LL,  },
    {  0xa6ba78d5d06035LL,  0x9a9de7907600f8LL,  0xe93a2e70d4b78eLL,  0xca1ab0f26f4027LL,  0x52714504521c42LL,  0x4b8f312250dfd6LL,  0x000c3213db162fLL,  },
    {  0x2057bff59006e1LL,  0xaee4ae8cb22754LL,  0x3a158421eae938LL,  0x265a8059d9fee3LL,  0xc3af4b54ffe802LL,  0xaef6fa85721a8aLL,  0x0019e875c7a7ecLL,  },
    {  0x957e7dd93b1c44LL,  0xd4864e6375f4e8LL,  0x615e569fa83347LL,  0xff751c3cb9f411LL,  0x82b4248796563dLL,  0x44f3103a557964LL,  0x0007a7a82b6f87LL,  },
    {  0x1c50658dc7255aLL,  0xfbdeb64bd5b508LL,  0x0e31629965c0f9LL,  0xdc3e32f9ddaf67LL,  0x34cba948aab07bLL,  0x5fd64edd208f93LL,  0x0019679604e589LL,  },
};

const bint_ty iso_xden[ELLP_XMAP_DEN_LEN] = {
    {  0xad77fdb0fd9a51LL,  0x1000d8cfa0bcf0LL,  0x124fc8c4d11ab8LL,  0x2d514b090fdbdaLL,  0xb84fc425b4a5d0LL,  0xa9c63ad344e7eeLL,  0x00139c83aec192LL,  },
    {  0xea3ba506dc8390LL,  0x0afcfad76a3907LL,  0xea3ea414493a0aLL,  0x5718b76aea08deLL,  0x7a41c2089282c4LL,  0xbeb5cc8c2957e4LL,  0x00132e3dbb89f9LL,  },
    {  0x57a644a01ea679LL,  0xcd96414ff0c144LL,  0xd7a3c1ff445138LL,  0xf78713b0cb3565LL,  0x5c7943823832d0LL,  0xab317f3699d020LL,  0x000721cf128db2LL,  },
    {  0x7d1182792b40c5LL,  0x901696f0fc13b0LL,  0x504df721db5236LL,  0xb6c0e9737a63e3LL,  0x29635732b09fafLL,  0x9b6e3e594fb7baLL,  0x000794220245d5LL,  },
    {  0x27ae6acb46256aLL,  0x334ede781f8d8cLL,  0x177ebfc1b50697LL,  0xb8920defc69649LL,  0x12b792b79f25b1LL,  0x54871d9b36f019LL,  0x00046cd06e63d3LL,  },
    {  0xc822cd142f1feaLL,  0x42951335b50d9dLL,  0xa85e5bb0fa640cLL,  0x71eeecb3508cdbLL,  0x70f8a9128c7eb1LL,  0x77e790b2e7da27LL,  0x0017f98f72c1c2LL,  },
    {  0xf01151b2683982LL,  0x65e2d511b3f57bLL,  0xd335d76bfc0b2cLL,  0x4a5bf52dc6f287LL,  0x3c23398fcfa49bLL,  0x20e16875a07f47LL,  0x000afce8984d72LL,  },
    {  0xf0747877164c08LL,  0x0d291b60f0a8acLL,  0xd9c0621366fda5LL,  0xcb1626190c32f8LL,  0xe78056b046659fLL,  0x26e85ad2dbadd8LL,  0x0000714b65f8b8LL,  },
    {  0x75439c133e522eLL,  0x3b0fb527a73c28LL,  0x31403c0cf341dcLL,  0x54df788e677513LL,  0x4648ea77adcbabLL,  0xe99d242ecadebdLL,  0x0013ae78ceb0c6LL,  },
    {  0xcbc97bacfc06c3LL,  0x73a8ce86c0cb80LL,  0x03dcbfcf900b6fLL,  0x7328c888c8af6bLL,  0x6e83d159bf7020LL,  0x0fca66ca78754eLL,  0x0010190981da73LL,  },
};

const bint_ty iso_ynum[ELLP_YMAP_NUM_LEN] = {
    {  0x00f3e2839d66d5LL,  0x5861fd53674e9dLL,  0xe86e476ae9d8f2LL,  0xb6c56d5b02f5c6LL,  0x047b429185fc0cLL,  0xdcbda22923aa80LL,  0x00157d3dcd308fLL,  },
    {  0xbc5fa5426b9433LL,  0xcccf1c2c78b5ecLL,  0xcc562d8276281fLL,  0x30bf3d5b6bbbccLL,  0x63196b7438cf87LL,  0x8d5c2b062c406aLL,  0x00173fa4851ecfLL,  },
    {  0x06922a5d378f14LL,  0xe46e61ce7d4972LL,  0x47768c198e0283LL,  0x486e9644044139LL,  0x2f891715674c1dLL,  0x77624f9aeba406LL,  0x000e3a3c37b93cLL,  },
    {  0x7095bfafe4102fLL,  0xa6f4ab5b077bcaLL,  0xa7648cdaeedc15LL,  0x19a5e73e28e016LL,  0x2d52edc0090a40LL,  0xc0638922ee6fdeLL,  0x000852d865b72dLL,  },
    {  0x84c7ff8a5c944aLL,  0xe39f3da6fd6257LL,  0x33f5274f653874LL,  0x1990e2003ab6d5LL,  0x149cd287ac98edLL,  0xece6f122067ba8LL,  0x0011fcdb49788bLL,  },
    {  0x1d31111bc3324fLL,  0xf5f2eb4d82aa63LL,  0x61d4b0a4f303fcLL,  0x2c0443c504fd27LL,  0xf333adf9e5fa4aLL,  0x765bc8118fa71dLL,  0x000fcb068b4399LL,  },
    {  0xbfb0d7a7f2fa91LL,  0x81e7f0f6197ab3LL,  0x615443b5052271LL,  0x5b830d30f33c8dLL,  0xdbfe3c7af1b579LL,  0xc3517b44aa1630LL,  0x0018c8c64e9465LL,  },
    {  0xff72f7c4f07932LL,  0x91010c8891b0dcLL,  0xc28a0bca419b5aLL,  0x201a4c44af0f47LL,  0xf7d374e4434f2dLL,  0xfe11e11e0f0b06LL,  0x0010ba38ea9a64LL,  },
    {  0xf3844e0da2a912LL,  0xa4597f6a33c850LL,  0x3dabcc2e500b99LL,  0x8033b735ebf823LL,  0x9ed60540b10cc1LL,  0x9de9cb035820d3LL,  0x0017c40f98ff87LL,  },
    {  0xaeb03c12e219b0LL,  0xfb43e88a1787ccLL,  0x00f1052bffd9b5LL,  0x02ecb32997c947LL,  0xea58766f222476LL,  0x9ada96f42a4c25LL,  0x0001bc972ca9f2LL,  },
    {  0x70ca89f1697b18LL,  0x109a454c4f381aLL,  0xb72ac9420b8876LL,  0x3f3c23d83925f6LL,  0x928444309d95f9LL,  0x26d5212cc8aee1LL,  0x00171ce3593575LL,  },
    {  0xd5900b8a456c4eLL,  0xec3754c9c4bb62LL,  0x14e718cde439afLL,  0x2ce9b0ac29a8f7LL,  0xd2b68b5990e057LL,  0xd2f620e7888981LL,  0x0005880df56773LL,  },
    {  0x30000746271fd5LL,  0x9dc74b7cf5d75dLL,  0x59eada4a5ae192LL,  0xe8ad7d0976a3f4LL,  0x98fa77a571e216LL,  0x9ec36e0ebf47adLL,  0x0012f17b95e9b1LL,  },
    {  0x96b538d6546a47LL,  0x19cd54663a9ecbLL,  0x4fe1964c5e0342LL,  0x0faf0969118089LL,  0x23f2c783dc87b0LL,  0x8d87ad6e40afa5LL,  0x000b2bcd782843LL,  },
    {  0x2b4b6e4087f076LL,  0x9cfa90fd9015a9LL,  0x3c2c636f46fadfLL,  0x6fc05c1f562766LL,  0x8a6eb0659155c4LL,  0x0bcd9d865fea1aLL,  0x000a7ffa89a41eLL,  },
    {  0x47c17d98864175LL,  0x16e4de822ab331LL,  0xc4d00536378227LL,  0x97b76da7ca2f03LL,  0x34f4de4689fa48LL,  0xb2bb7cc89c3b38LL,  0x0012db8d66f3a3LL,  },
};

const bint_ty iso_yden[ELLP_YMAP_DEN_LEN] = {
    {  0x9c9d47e54d7133LL,  0x8a970a81610796LL,  0xc55c287590982bLL,  0x018898db75cce1LL,  0xe9dec8d2727a48LL,  0x293ebc368661f9LL,  0x001529e9a7541cLL,  },
    {  0xd64f5535ed5022LL,  0x745f2f51118b86LL,  0x0ef5f1c8b4eb8bLL,  0x481911ce4bee11LL,  0x817cabe11c90a9LL,  0x85990539c17edaLL,  0x00094b3094d50dLL,  },
    {  0xc76df4700b46a5LL,  0x59ba0cd342308fLL,  0x20aa69debe9955LL,  0xb9b20e5b83807eLL,  0x147a68b75e615aLL,  0xf0c601b58f9e60LL,  0x00089571c92d1dLL,  },
    {  0x9fef3b75db3073LL,  0x75511b3b402026LL,  0x8b41ddcdf98902LL,  0x3538cb47f75504LL,  0xe6ca4656e99343LL,  0x4eb2b1b717904aLL,  0x000cca25bfbb50LL,  },
    {  0xba2ea267fc709dLL,  0x1c956743003cfdLL,  0xf304a64554d5e3LL,  0xe952a42b867e27LL,  0x8eebbd97377773LL,  0x0cfbc578bf39e2LL,  0x001967dcdff819LL,  },
    {  0x52efeeb5e6928cLL,  0x8a55b88b55df97LL,  0x1871ffa89d1ef2LL,  0x85470fa89c1921LL,  0x740aa834e28733LL,  0xf49b4beebc5913LL,  0x0013d7994a887bLL,  },
    {  0x8ceb5fae18f3d7LL,  0x0b2923ccf0bc5eLL,  0xbee26d08d82001LL,  0x6416b2048b2e3eLL,  0x16834772112909LL,  0x21b2505dc10779LL,  0x000350c8d5ac43LL,  },
    {  0x720e5b8c0f5ad5LL,  0x965a8d253064e0LL,  0x7ee4b8f7a6f038LL,  0xae16545835a4dbLL,  0x524d14fede16abLL,  0xd330b443e5323aLL,  0x0018edfb375300LL,  },
    {  0x4192ec7504a4cfLL,  0xab5fd8f897a6e7LL,  0x30e8d93105a4f0LL,  0x87542773a4fa97LL,  0x8653550f596f4fLL,  0x4abd2b47e800c7LL,  0x000525e9f2de8cLL,  },
    {  0xa0d449f6d72dd5LL,  0x5d61da2630a22fLL,  0xfd1be778b26111LL,  0x98c1b1043af281LL,  0x8c95475d846418LL,  0xcbace06e8ccf8dLL,  0x00084b9d05f309LL,  },
    {  0x0b9285fd936e47LL,  0xa8684e6d7c02eaLL,  0xfc08db56cb7671LL,  0xa97ed24ef4a55bLL,  0x9301e9a40fb1e8LL,  0xe3124bb9924e0dLL,  0x0009d1ac9a9748LL,  },
    {  0x496a7c38981ac7LL,  0x0eca4d0003f039LL,  0x9f25af4b593fafLL,  0x7928bf7a742aa8LL,  0xc7598e04d32c8dLL,  0xf672629617b836LL,  0x000c38afd4aa0cLL,  },
    {  0x02bf274511b45aLL,  0x0676c8c9545249LL,  0xc6f3ad5496f2f5LL,  0xa8859ab160cc82LL,  0x7f705f07d7e5e8LL,  0x3eddffdd7f8a1fLL,  0x00095cf4dcb1efLL,  },
    {  0x176ca1579fd1bfLL,  0x991bf51f55b410LL,  0x1aebfea4612056LL,  0x06c3848c1885b5LL,  0xdb4b9f1adb7dddLL,  0x2f113d78c3eccdLL,  0x000f0b1f0fd115LL,  },
    {  0x322e39837a34cfLL,  0x2d7ddd20213164LL,  0x354fc73c4601d1LL,  0x32faa36d796eb7LL,  0xffef4e5463826eLL,  0xa46274a1e0d4d3LL,  0x000b25054daaecLL,  },
};

// clang-format on
